
module inputconditioner(clk, noisysignal, conditioned, positiveedge, negativeedge);
output reg conditioned = 0;
output reg positiveedge = 0;
output reg negativeedge = 0;
input clk, noisysignal;

parameter counterwidth = 3;
parameter waittime = 3;

reg[counterwidth-1:0] counter =0;
reg synchronizer0 = 0;
reg synchronizer1 = 0;

always @(posedge clk ) begin
	if(conditioned == synchronizer1)
		counter <= 0;
	else begin
		if( counter == waittime) begin
			counter <= 0;
			conditioned <= synchronizer1;
		end
		else 
			counter <= counter+1;
	end
	synchronizer1 = synchronizer0;
	synchronizer0 = noisysignal;
end
endmodule


module testConditioner;
wire conditioned;
wire rising;
wire falling;
reg pin, clk;
reg ri;
always @(posedge clk) ri=rising;
inputconditioner dut(clk, pin, conditioned, rising, falling);

initial clk=0;
always #10 clk=!clk;	// 50MHz Clock

initial begin
pin =0;
#250
pin = 1;
#500 
pin = 0;
#500
pin = 1;
#50
pin = 0;
#50
pin = 1;
end

endmodule
